;
;	SD card file control program
;
	ORG	0000H
;

FIRMVER:	EQU	00044H

;FIRMVER:	EQU	08420H	; decode address for debug

INITSP:		EQU	1FFFH
;
; buffer location
;
REG_SDBUF:	EQU	8000H
REG_OFFSET:	EQU	81C6H

BPB_SECBYTE	EQU	800BH
BPB_CLASTSEC:	EQU	800DH
BPB_FATST:	EQU	800EH
BPB_FATNUM	EQU	8010H
BPB_DIRENTRY	EQU	8011H
BPB_FATSEC:	EQU	8016H
BPB_FATVER:	EQU	8039H

;
; register mapping
;
REG_SDCMDST:	EQU	8200H
REG_SDCTRL:	EQU	8201H
REG_SDRDDONE:	EQU	8202H
REG_ROMINIT:	EQU	8203H
REG_SDWP:	EQU	8204H
REG_SDCMDNO:	EQU	8205H
REG_SDADD:	EQU	8206H

REG_BUFAD:	EQU	8210H
REG_BUFSEL:	EQU	8211H
REG_CMTOPEN:	EQU	8212H
REG_SDRD:	EQU	8213H
REG_SDWR:	EQU	8214H
REG_CMTRD:	EQU	8234H
REG_CMTWR:	EQU	8254H

REG_FIFO_0:	EQU	8220H
REG_FIFO_1:	EQU	8240H
REG_FIFO_2:	EQU	8260H

FIFO_CMTLEN:	EQU	00H
FIFO_CMTPTR:	EQU	04H
FIFO_CL:	EQU	08H
FIFO_SEC:	EQU	0AH
FIFO_STCL:	EQU	0BH
FIFO_BEFCL:	EQU	0DH
FIFO_DIRCL:	EQU	0FH
FIFO_DIRPOS:	EQU	11H
FIFO_FATNEW:	EQU	13H
FIFO_STAT:	EQU	14H
FIFO_WRADD:	EQU	15H

REG_CMTWNOM:	EQU	8300H
REG_CMTWACC:	EQU	8304H
REG_CMTWST:	EQU	8308H
REG_ACCCNT:	EQU	830CH

REG_LCDMODE:	EQU	8400H
REG_LCDADD:	EQU	8401H
REG_LCDDAT:	EQU	8402H
REG_LCDST:	EQU	8403H
REG_LCDDONE:	EQU	8404H
REG_CTRLSEL:	EQU	8410H
REG_CTRLRST:	EQU	8411H
REG_MEM16K:	EQU	8412H
REG_SC4MODE:	EQU	8413H
REG_DBGTRG:	EQU	8414H
REG_MK2MODE:	EQU	8415H
REG_KEYDAT:	EQU	8416H
REG_KEYENB:	EQU	8417H

REG_FUNCKEY:	EQU	8420H

REG_FPGAVER:	EQU	8440H
REG_FIRMVER:	EQU	8442H

F_BASICROM:	EQU	8480H
F_CGROM:	EQU	8490H
F_CG2ROM:	EQU	84A0H
F_KANJIROM:	EQU	84B0H
F_VOICEROM:	EQU	84C0H

CTRLATT:	EQU	0C000H
CTRLVRAM:	EQU	0C200H

;

START:

	LD	SP,INITSP
	LD	A,0FFH
	LD	I,A
	EI
	LD	HL,FIRMVER
	LD	(REG_FIRMVER),HL
	XOR	A
	LD	(REG_DBGTRG),A

		;
	CALL	LCD_INIT
	CALL	SCREENINIT
		;
	XOR	A
	LD	(SDMODE),A

		;
	CALL	SDCARD_OPEN
	CALL	SDREGINIT
		;
	LD	DE,ST_EXTROM_VAL
	CALL	LD_ST_NOSELECT


		;
		; BASICROM read
		;
	LD	IX,F_BASICROM
	LD	HL,0000H
	LD	DE,0002H
	LD	A,(REG_MK2MODE)
	OR	A
	JR	Z,RDM2_B
	LD	DE,0003H
RDM2_B:	CALL	ROMFILEREAD
		;
		; CGROM read
		;
	LD	IX,F_CGROM
	LD	HL,0A000H
	LD	DE,0002H
	LD	A,(REG_MK2MODE)
	OR	A
	JR	Z,RDM2_C
	LD	DE,0003H
RDM2_C:	CALL	ROMFILEREAD
		;
	LD	A,(REG_MK2MODE)
	OR	A
	JR	Z,READEND
		;
		; CG2ROM read
		;
	LD	IX,F_CG2ROM
	LD	HL,08000H
	LD	DE,0003H
	CALL	ROMFILEREAD
		;
		; KANJIROM read
		;
	LD	IX,F_KANJIROM
	LD	HL,0000H
	LD	DE,0004H
	CALL	ROMFILEREAD
		;
		; VOICEROM read
		;
	LD	IX,F_VOICEROM
	LD	HL,0C000H
	LD	DE,0003H
	CALL	ROMFILEREAD

READEND:
	CALL	ROMINIT

	LD	A,01H
	LD	(REG_SDRDDONE),A

	LD	A,01H
	LD	(SDMODE),A


MAINSTART:
	LD	A,02H
	LD	(SDMODE),A
	CALL	SDCARD_OPEN
	CALL	SDREGINIT
MAINST2:
	LD	A,01H
	LD	(SDMODE),A
	CALL	SDREGINIT
	CALL	SDADDINIT

	CALL	KEYBUFINIT

	XOR	A
	LD	(EXTROMFLAG),A
	LD	(REG_KEYENB),A

;
; main loop
;
MLP10:
	CALL	KEYDET
	LD	A,(FUNCPUSH+1)
	AND	08H
	JR	Z,MLP11

;
; F11 (reset)
;
	LD	HL,REG_CTRLSEL
	LD	(HL),01H
	LD	(HL),00H

	LD	HL,P6TCMDENB
	LD	A,(HL)
	XOR	01H
	LD	(HL),A
	XOR	A
	LD	(REG_KEYENB),A

	JR	MLP10

MLP11:
	CALL	DETSDEJECT
	CALL	CMTREADWAIT
	CALL	CMTWRITEWAIT
	CALL	P6TKEYWAIT

	LD	A,(CTRLNOW)
	AND	10H
	JR	Z,MLP10
	LD	A,(CTRLPUSH)
	AND	10H

	CALL	NZ,PAGEINIT

;
; control panel display
;
MLP12:

	CALL	DISPPAGE
	CALL	DISPCUR

	CALL	KEYINPAGE

	JR	MLP10



;
; page # keyin process
;
KEYINPAGE:
	LD	A,(PAGENUM)
	OR	A
	JP	Z,KEYINPAGE0
	CP	01H
	JP	Z,KEYINPAGE1
	CP	02H
	JP	Z,KEYINPAGE2

	RET

;
; page 0 keyin process
;
KEYINPAGE0:

	LD	HL,FUNCPUSH
		; F7 - F0,ESC

	INC	HL
		; TAB,RETURN,SPACE,F12 - F8

	BIT	6,(HL)
	JP	Z,KP0L0

;
; return
;
	LD	A,01H
	LD	(PAGEREDRAW),A
	LD	(CURSORREDRAW),A

	LD	HL,(CURSOR_ADD)
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	A,H
KP0L00:	SUB	03H
	JR	NZ,KP0L01

	LD	A,04H
	LD	(FILESEL),A
	CALL	FILESELINIT
	RET

KP0L01:	CP	01H
	JR	NZ,KP0L03

	LD	HL,REG_CMTRD
	LD	(HL),02H
	LD	(HL),00H
	LD	A,(READFLAG)
	OR	A
	RET	Z

	LD	HL,(REG_FIFO_0+FIFO_STCL)
	LD	(REG_FIFO_0+FIFO_CL),HL
	XOR	A
	LD	(REG_FIFO_0+FIFO_SEC),A
	INC	A
	LD	(READFLAG),A
	RET

KP0L03:	CP	03H
	JR	NZ,KP0L05

	LD	A,(REG_SDWP)
	OR	A
	RET	NZ
	LD	A,0CH
	LD	(FILESEL),A
	CALL	FILESELINIT
	RET

KP0L05:	CP	05H
	JR	NZ,KP0L07

	LD	HL,REG_MEM16K
	LD	A,(HL)
	XOR	01H
	LD	(HL),A

	LD	HL,REG_CTRLRST
	LD	(HL),01H
	LD	(HL),00H
	RET

KP0L07:	CP	07H
	JR	NZ,KP0L09

	LD	A,05H
	LD	(FILESEL),A
	CALL	FILESELINIT
	RET

KP0L09:	CP	09H
	RET	NZ

	LD	HL,REG_SC4MODE
	LD	A,(HL)
	BIT	4,A
	JR	NZ,KP0L091
	OR	10H
	AND	0FCH
	LD	(HL),A
	RET

KP0L091:
	AND	03H
	INC	A
	AND	03H
	LD	B,A
	LD	A,(HL)
	JR	NZ,KP0L092
	AND	0EFH
KP0L092:
	AND	0FCH
	OR	B
	LD	(HL),A
	RET


KP0L0:	INC	HL
		; END,ALT,SHIFT,CTRL,<-,->,v,^

	BIT	0,(HL)
	JR	Z,KP0L1

;
; cursor up
;
	LD	C,0FFH
	JR	PAGE0CURMOV

KP0L1:
	BIT	1,(HL)
	RET	Z

;
; cursor down
;
	LD	C,01H
	JR	PAGE0CURMOV

;
; page 0 keyin sub
;
PAGE0CURMOV:
	LD	A,01H
	LD	(CURSORREDRAW),A

	LD	HL,(CURSOR_ADD)
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	A,H
	SUB	03H

	ADD	A,C
	CP	0AH
	RET	NC

	CP	02H
	JR	NZ,P0CL0
	ADD	A,C
P0CL0:
	CP	04H
	JR	NZ,P0CL1
	ADD	A,C
P0CL1:
	CP	06H
	JR	NZ,P0CL2
	ADD	A,C
P0CL2:
	CP	08H
	JR	NZ,P0CL3
	ADD	A,C
P0CL3:
	LD	B,A
	ADD	A,A
	ADD	A,B
	LD	E,A
	LD	D,00H
	LD	HL,PAGE0CURDATA
	ADD	HL,DE
	LD	DE,CURSOR_ADD
	LD	BC,0003H
	LDIR

	RET

;
; page 0 keyin sub
; file selector initialize
;
FILESELINIT:
	LD	HL,0000H
	LD	(DIRCL),HL
	DEC	HL
	LD	(DIRPOS),HL
	LD	A,01H
	LD	(PAGENUM),A
	CALL	SDADDINIT
		;
	LD	A,(FILESEL)
	CP	04H
	JR	NZ,FSIL1
		;
	LD	IY,REG_FIFO_0
	XOR	A
	LD	(REG_BUFAD),A
	RET
FSIL1:	CP	05H
	JR	NZ,FSIL2
		;
	LD	IY,REG_FIFO_0
	XOR	A
	LD	(REG_BUFAD),A
	RET
FSIL2:	CP	06H
	JR	NZ,FSIL3
		;
	LD	IY,REG_FIFO_2
	LD	A,02H
	LD	(REG_BUFAD),A
	RET
FSIL3:	CP	0CH
	JR	NZ,FSIL4
		;
	LD	IY,REG_FIFO_1
	LD	A,01H
	LD	(REG_BUFAD),A
	RET
FSIL4:	CP	0EH
	JR	NZ,FSIL5
		;
	LD	IY,REG_FIFO_2
	LD	A,02H
	LD	(REG_BUFAD),A
	RET
FSIL5:	JR	FSIL5

;
; page 1 keyin process
;
KEYINPAGE1:

	LD	HL,FUNCPUSH
		; F7 - F0,ESC

	BIT	0,(HL)
	JR	Z,KP1L0

;
; ESC
;
PAGEINIT:
	XOR	A
	LD	(PAGENUM),A
	INC	A
	LD	(PAGEREDRAW),A
	LD	(CURSORREDRAW),A

	LD	HL,PAGE0CURDATA
	LD	DE,CURSOR_ADD
	LD	BC,0003H
	LDIR

	RET

KP1L0:	INC	HL
		; TAB,RETURN,SPACE,F12 - F8

	BIT	5,(HL)
	JR	Z,KP1L1

;
; space
;
PAGE1REDRAW:
	LD	A,01H
	LD	(PAGENUM),A
	LD	(PAGEREDRAW),A
	LD	(CURSORREDRAW),A
	RET

KP1L1:	BIT	6,(HL)
	JP	Z,KP1L2

;
; return
;
	LD	HL,(CURSOR_ADD)
	CALL	CUR2BUF
	INC	HL
	LD	A,H
	OR	L
	DEC	HL
	JR	NZ,KP1L1_SEL1

		;
		; file "no select"
		;
	LD	A,(FILESEL)
	CP	04H
	JR	NZ,KP1L1_NOSEL1
		;
		; CMT load "no select"
		;
	CALL	SDREGINIT_0

	LD	DE,ST_CMTREAD_VAL

KP1L1_NOSELEND:
	CALL	LD_ST_NOSELECT
	CALL	PAGEINIT
	RET

KP1L1_NOSEL1:
	CP	05H
	JR	NZ,KP1L1_NOSEL2
		;
		; EXT.ROM "no select"
		;
	LD	A,01H
	LD	(REG_CTRLRST),A
	CALL	ROMINIT
	XOR	A
	LD	(REG_CTRLRST),A

	CALL	SDREGINIT_0

	XOR	A
	LD	(EXTROMFLAG),A

	LD	DE,ST_EXTROM_VAL
	JR	KP1L1_NOSELEND

KP1L1_NOSEL2:
	CP	0CH
	JR	NZ,KP1L1_NOSEL3
		;
		; CMT save "no select"
		;
	CALL	SDREGINIT_1

	LD	DE,ST_CMTWRITE_VAL
	JR	KP1L1_NOSELEND

KP1L1_NOSEL3:
	JR	KP1L1_NOSEL3


		;
		; file / directory judge
		;
KP1L1_SEL1:
	LD	(DIRPOS),HL
		;
	LD	A,01H
	LD	(REG_SDCTRL),A
	CALL	READ_DIRFILE
	XOR	A
	LD	(REG_SDCTRL),A
		;
	LD	BC,000BH
	ADD	HL,BC
	LD	A,(HL)
	LD	BC,000FH
	ADD	HL,BC
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	DEC	HL
	AND	10H
	JR	Z,KP1L11

		;
		; select directory
		;
	EX	DE,HL
	LD	(DIRCL),HL
	LD	A,H
	OR	L
	LD	HL,0FFFFH
	JR	Z,KP1L1_ROOT
	INC	HL
KP1L1_ROOT:
	LD	(DIRPOS),HL
	CALL	PAGE1REDRAW
	RET

KP1L11:
	LD	A,(FILESEL)
	CP	04H
	JR	NZ,KP1L1_FS1

		;
		; CMT load file name
		;
	CALL	SDREGINIT_0
	CALL	SETFILEPARA

	LD	A,01H
	LD	(READFLAG),A

	LD	DE,ST_CMTREAD_VAL
	LD	HL,(CURSOR_ADD)
	LD	BC,CTRLVRAM
	ADD	HL,BC
	PUSH	HL
	LD	BC,000CH
	LDIR

	XOR	A
	LD	(P6TFILEREAD),A

	POP	HL
	LD	DE,0009H
	ADD	HL,DE
	LD	DE,ST_P6T
	LD	B,03H
	CALL	CP_MHL_MDE
	JR	NZ,KP1L1_NOP6T

	CALL	READP6T
	LD	(P6TFILEREAD),A

KP1L1_NOP6T:
	CALL	PAGEINIT

	RET

KP1L1_FS1:
	CP	05H
	JR	NZ,KP1L1_FS2

		;
		; EXT. ROM load file name
		;
	CALL	SDREGINIT_0
	CALL	SETFILEPARA

	LD	DE,ST_EXTROM_VAL
	LD	HL,(CURSOR_ADD)
	LD	BC,CTRLVRAM
	ADD	HL,BC
	LD	BC,000CH
	LDIR

	LD	DE,ST_CMTREAD_VAL
	CALL	LD_ST_NOSELECT

	CALL	PAGEINIT


	LD	A,01H
	LD	(REG_CTRLRST),A
		;
	CALL	ROMINIT
		;
	XOR	A
	LD	(REG_BUFAD),A
	LD	(IY+FIFO_CMTPTR+0),00H
	LD	(IY+FIFO_CMTPTR+1),0C0H
	LD	(IY+FIFO_CMTPTR+2),02H
	LD	(IY+FIFO_CMTPTR+3),00H
		;
	CALL	FILEREAD
		;
	XOR	A
	LD	(REG_CTRLRST),A
		;
	CALL	SDREGINIT_0
		;
	LD	A,01H
	LD	(EXTROMFLAG),A

	RET


KP1L1_FS2:
	CP	0CH
	JR	NZ,KP1L1_FS3

		;
		; CMT save file name
		;
	CALL	SDREGINIT_1
	CALL	SETFILEPARA

	LD	DE,ST_CMTWRITE_VAL
	LD	HL,(CURSOR_ADD)
	LD	BC,CTRLVRAM
	ADD	HL,BC
	LD	BC,000CH
	LDIR

	CALL	PAGEINIT

	LD	A,04H
	LD	(REG_CMTWR),A

	LD	A,01H
	LD	(WRITEFLAG),A

	RET


KP1L1_FS3:
	JR	NZ,KP1L1_FS3


KP1L2:	INC	HL
		; END,ALT,SHIFT,CTRL,<-,->,v,^

	BIT	0,(HL)
	JR	Z,KP1L3

;
; cursor up
;
	LD	A,01H
	LD	(CURSORREDRAW),A

	LD	HL,(CURSOR_ADD)
	EX	DE,HL
	LD	HL,0072H
	OR	A
	SBC	HL,DE
	RET	NC

	LD	HL,0020H
	EX	DE,HL
	OR	A
	SBC	HL,DE
	LD	(CURSOR_ADD),HL

	RET

KP1L3:
	BIT	1,(HL)
	JR	Z,KP1L4

;
; cursor down
;
	LD	A,01H
	LD	(CURSORREDRAW),A

	LD	HL,(CURSOR_ADD)
	EX	DE,HL
	LD	HL,0182H-1
	OR	A
	SBC	HL,DE
	RET	C

	LD	HL,(CURSOR_ADD)
	LD	DE,0020H
	ADD	HL,DE
	CALL	CUR2CHK
	RET	Z

	LD	HL,(CURSOR_ADD)
	LD	DE,0020H
	ADD	HL,DE
	LD	(CURSOR_ADD),HL
	RET

KP1L4:
	BIT	2,(HL)
	JR	Z,KP1L5

;
; cursor right
;
	LD	A,01H
	LD	(CURSORREDRAW),A

	LD	HL,(CURSOR_ADD)
	LD	A,L
	AND	1FH
	CP	12H
	RET	NC

	LD	HL,(CURSOR_ADD)
	LD	DE,0010H
	ADD	HL,DE
	CALL	CUR2CHK
	RET	Z

	LD	HL,(CURSOR_ADD)
	LD	DE,0010H
	ADD	HL,DE
	LD	(CURSOR_ADD),HL

	RET

KP1L5:
	BIT	3,(HL)
	RET	Z

;
; cursor left
;
	LD	A,01H
	LD	(CURSORREDRAW),A

	LD	HL,(CURSOR_ADD)
	LD	A,L
	AND	1FH
	CP	02H+1
	RET	C

	LD	DE,0010H
	OR	A
	SBC	HL,DE
	LD	(CURSOR_ADD),HL

	RET



;
; cursor position -> file buffer positon (keyin 1 sub)
;
; HL <- cursor position
;
; RETURN HL:file buffer position
;
CUR2BUF:
	LD	DE,0062H
	OR	A
	SBC	HL,DE
	SRL	H
	RR	L
	SRL	H
	RR	L
	SRL	H
	RR	L
	LD	DE,FILEPTR_BUF
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL
	RET

;
; cursor position -> file buffer positon (keyin 1 sub)
;
; HL <- cursor position
;
; RETURN Zflag set:file NULL
;
CUR2CHK:
	CALL	CUR2BUF
	INC	HL
	LD	A,L
	OR	H
	RET

;
; set file parameter
; IX <= file name address
;
SETFILEPARA:
	PUSH	HL
	LD	HL,(DIRCL)
	LD	(IY+FIFO_DIRCL+0),L
	LD	(IY+FIFO_DIRCL+1),H
	LD	HL,(DIRPOS)
	LD	(IY+FIFO_DIRPOS+0),L
	LD	(IY+FIFO_DIRPOS+1),H
	POP	HL

SETFILEPARA2:
	LD	A,(HL)
	LD	(IY+FIFO_CL+0),A
	LD	(IY+FIFO_STCL+0),A
	INC	HL
	LD	A,(HL)
	LD	(IY+FIFO_CL+1),A
	LD	(IY+FIFO_STCL+1),A
	INC	HL
	LD	A,(HL)
	LD	(IY+FIFO_CMTLEN+0),A
	INC	HL
	LD	A,(HL)
	LD	(IY+FIFO_CMTLEN+1),A
	INC	HL
	LD	A,(HL)
	LD	(IY+FIFO_CMTLEN+2),A
	INC	HL
	LD	A,(HL)
	LD	(IY+FIFO_CMTLEN+3),A

	RET

;
; page 2 keyin process
;
KEYINPAGE2:

	RET


;
; page # display
;
DISPPAGE:
	LD	A,(PAGEREDRAW)
	OR	A
	RET	Z

	CALL	SCREENINIT

	XOR	A
	LD	(PAGEREDRAW),A
	INC	A
	LD	(CURSORREDRAW),A

	LD	A,(PAGENUM)
	OR	A
	JP	Z,DISPPAGE0
	CP	01H
	JP	Z,DISPPAGE1
	CP	02H
	JP	Z,DISPPAGE2

	RET


;
; page 0 display
;
DISPPAGE0:
	LD	HL,ST_32
	LD	A,(REG_MEM16K)
	OR	A
	JR	Z,DP0L2
	LD	HL,ST_16
DP0L2:
	LD	A,(REG_MK2MODE)
	OR	A
	JR	Z,DP0L21
	LD	HL,ST_64
	LD	A,(REG_MEM16K)
	OR	A
	JR	Z,DP0L21
	LD	HL,ST_128
DP0L21:
	LD	DE,ST_MEMSIZE_VAL
	LD	BC,0003H
	LDIR

	LD	HL,ST_SC4COLOFF
	LD	A,(REG_SC4MODE)
	BIT	4,A
	JR	Z,DP0L5
	LD	HL,ST_SC4COL0
	AND	03H
	JR	Z,DP0L5
	LD	HL,ST_SC4COL1
	CP	01H
	JR	Z,DP0L5
	LD	HL,ST_SC4COL2
	CP	02H
	JR	Z,DP0L5
	LD	HL,ST_SC4COL3
DP0L5:	LD	DE,ST_SC4COL_VAL
	LD	BC,0008H
	LDIR

	LD	HL,ST_CMTREAD
	CALL	PRINTSTRING
	LD	HL,ST_CMTREW
	CALL	PRINTSTRING
	LD	HL,ST_CMTWRITE
	CALL	PRINTSTRING
	LD	HL,ST_MEMSIZE
	CALL	PRINTSTRING
	LD	HL,ST_EXTROM
	CALL	PRINTSTRING
	LD	HL,ST_SC4COL
	CALL	PRINTSTRING

	RET

;
; page 1 display
;
DISPPAGE1:
	LD	A,01H
	LD	(REG_SDCTRL),A

	LD	B,28H
	LD	HL,FILEPTR_BUF
P1LP10:	LD	(HL),0FFH
	INC	HL
	DJNZ	P1LP10
		;
	LD	HL,0062H
	LD	(ST_FNAME),HL
		;
P1LP11:	LD	B,14H
	LD	DE,FILEPTR_BUF
P1LP13:	PUSH	BC
	PUSH	DE
P1LP15: LD	HL,(DIRPOS)
	INC	HL
	LD	A,H
	OR	L
	JR	NZ,P1LP151
		;
		; "NO SELECT"
		;
	LD	(DIRPOS),HL
	LD	DE,ST_FNAME_VAL
	CALL	LD_ST_NOSELECT
	JR	P1LP18

P1LP131:JR	P1LP13

P1LP151:
	CALL	READ_DIRFILE

	PUSH	HL
	LD	HL,(DIRPOS)
	LD	A,H
	INC	HL
	LD	(DIRPOS),HL
	POP	HL
	CP	02H
	JR	NC,P1LP14

	LD	A,(HL)
	OR	A
	JR	Z,P1LP14
	CP	05H
	JR	Z,P1LP15
	CP	0E5H
	JR	Z,P1LP15
	CP	"."
	JR	NZ,P1LP16
	INC	HL
	LD	A,(HL)
	DEC	HL
	CP	" "
	JR	Z,P1LP15

P1LP16: LD	DE,ST_FNAME_VAL
	LD	BC,0008H
	LDIR
	LD	A,"."
	LD	(DE),A
	INC	DE
	LD	BC,0003H
	LDIR
	LD	A,(HL)
	LD	B,A
	AND	0EH
	JR	NZ,P1LP15
	LD	A,(FILESEL)
	CP	0CH
	JR	NZ,P1LP161
	LD	A,B
	AND	01H
	JR	NZ,P1LP15
P1LP161:
	LD	A,B
	AND	10H
	JR	Z,P1LP18
	LD	A,"="
	DEC	DE
	LD	(DE),A
	DEC	DE
	LD	(DE),A
	DEC	DE
	LD	(DE),A
	DEC	DE
	LD	(DE),A

P1LP18:	LD	HL,(DIRPOS)
	DEC	HL
	EX	DE,HL
	POP	HL
	PUSH	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D

	LD	HL,ST_FNAME
	CALL	PRINTSTRING

	LD	HL,(ST_FNAME)
	LD	DE,0010H
	ADD	HL,DE
	LD	(ST_FNAME),HL
	POP	DE
	INC	DE
	INC	DE
	POP	BC
	DJNZ	P1LP131

P1LP12:	LD	HL,0062H
	LD	(CURSOR_ADD),HL
	LD	A,0CH
	LD	(CURSOR_LEN),A
	XOR	A
	LD	(REG_SDCTRL),A
	RET

		;
		; directory entry end
		;
P1LP14:	POP	DE
	POP	BC
	LD	HL,(DIRCL)
	LD	A,H
	OR	L
	LD	HL,0FFFFH
	JR	Z,P1LP141
	INC	HL
P1LP141:
	LD	(DIRPOS),HL
	LD	A,B
	CP	14H
	JP	Z,P1LP11
	JR	P1LP12


;
; page 2 display
;
DISPPAGE2:

	RET

;
; cursor display
;
DISPCUR:
	LD	A,(CURSORREDRAW)
	OR	A
	RET	Z

	LD	DE,CTRLATT+41H
	LD	HL,CTRLATT+40H
	LD	BC,017FH

	LD	(HL),22H
	LD	A,(REG_MK2MODE)
	OR	A
	JR	Z,DCL2
	LD	(HL),20H
DCL2:
	LDIR

	LD	A,(CURSOR_LEN)
	LD	B,A
	LD	HL,(CURSOR_ADD)
	LD	DE,CTRLATT
	ADD	HL,DE
DCL1:	LD	(HL),23H
	INC	HL
	DJNZ	DCL1

	XOR	A
	LD	(CURSORREDRAW),A
	RET


;
; screen initialize
;
SCREENINIT:
	LD	DE,CTRLATT+1
	LD	HL,CTRLATT
	LD	BC,0040H
	LD	(HL),20H
	LD	A,(REG_MK2MODE)
	OR	A
	JR	Z,SIL_TOP
	LD	(HL),23H
SIL_TOP:

	LDIR
	LD	BC,0180H
	LD	(HL),22H
	LD	A,(REG_MK2MODE)
	OR	A
	JR	Z,SIL_MID
	LD	(HL),20H
SIL_MID:

	LDIR
	LD	BC,0040H
	LD	(HL),20H
	LD	A,(REG_MK2MODE)
	OR	A
	JR	Z,SIL_BOT
	LD	(HL),23H
SIL_BOT:
	LDIR
	LD	BC,01FFH
	LD	(HL),20H


	LDIR

	LD	HL,(REG_FIRMVER)
	LD	DE,ST_FIRMVER_VAL
	CALL	VER_CONV
	LD	HL,(REG_FPGAVER)
	LD	DE,ST_FPGAVER_VAL
	CALL	VER_CONV

	LD	HL,ST_PC6001F
	CALL	PRINTSTRING
	LD	HL,ST_FPGAVER
	CALL	PRINTSTRING
	LD	HL,ST_FIRMVER
	CALL	PRINTSTRING

	LD	HL,ST_KEYFUNC1
	CALL	PRINTSTRING
	LD	HL,ST_KEYFUNC2
	CALL	PRINTSTRING

	RET

;
; version number convert
;
VER_CONV
	LD	B,02H

VCL1:
	LD	A,H
	AND	0F0H
	RRCA
	RRCA
	RRCA
	RRCA
	ADD	A,30H
	CP	3AH
	JR	C,VCL2
	ADD	A,07H
VCL2:	LD	(DE),A
	INC	DE
	LD	A,H
	AND	0FH
	ADD	A,30H
	CP	3AH
	JR	C,VCL3
	ADD	A,07H
VCL3:	LD	(DE),A
	INC	DE
	LD	H,L
	DJNZ	VCL1
	RET


;
; print strings
;
; HL <- pointer of strings with display address
;
PRINTSTRING:
	LD	DE,CTRLVRAM
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	EX	DE,HL
	ADD	HL,BC
	EX	DE,HL

PSL1:
	LD	A,(HL)
	OR	A
	RET	Z
	LD	(DE),A
	INC	HL
	INC	DE
	JR	PSL1


;
; debug
;
; HL <- print number
;
;PRINTHL:
;	LD	DE,ST_DEBUG_VAL
;	CALL	VER_CONV
;	LD	HL,ST_DEBUG
;	CALL	PRINTSTRING
;	RET


;
; key push detect
;
KEYDET:
	LD	HL,CTRLNOW
	LD	DE,CTRLBEF
	LD	IX,REG_CTRLSEL
	LD	IY,CTRLPUSH
	LD	B,04H

KDLP1:	LD	A,(HL)
	LD	(DE),A
	LD	A,(IX+00H)
	LD	(HL),A
	LD	A,(DE)
	XOR	(HL)
	AND	(HL)
	LD	(IY+00H),A

	INC	HL
	INC	DE
	INC	IY
	LD	A,B
	CP	04H
	JR	NZ,KDLP2
	LD	IX,REG_FUNCKEY-1
KDLP2:	INC	IX
	DJNZ	KDLP1

	RET


;
; read file
;
CMTREADWAIT:
	LD	A,(READFLAG)
	OR	A
	RET	Z
	DEC	A
	JR	NZ,CRWL1

		;
		; read file (new)
		;
	LD	A,(REG_CMTOPEN)
	AND	01H
	RET	Z

	LD	A,01H
	LD	(REG_SDCTRL),A

	XOR	A
	LD	(REG_BUFAD),A
	LD	A,04H
	LD	(FILESEL),A
	LD	IY,REG_FIFO_0
		;
	CALL	FILEREAD

	XOR	A
	LD	(REG_SDCTRL),A
	LD	A,02H
	LD	(READFLAG),A
	RET

		;
		; read file (continue)
		;
CRWL1:
	LD	A,(REG_CMTOPEN)
	AND	01H
	RET	Z

	LD	A,01H
	LD	(REG_SDCTRL),A

	XOR	A
	LD	(REG_BUFAD),A
	LD	A,04H
	LD	(FILESEL),A
	LD	IY,REG_FIFO_0
		;
	CALL	READCONT

	XOR	A
	LD	(REG_SDCTRL),A
	RET


;
; write file
;
CMTWRITEWAIT:
	LD	A,(WRITEFLAG)
	OR	A
	RET	Z
	DEC	A
	JP	NZ,CWW_FL2


		;
		; WRITEFLAG = 1
		;
	LD	A,(REG_CMTOPEN)
	AND	02H
	RET	Z

		;
	LD	A,01H
	LD	(REG_SDCTRL),A
	LD	(REG_BUFAD),A
	LD	IY,REG_FIFO_1

		;
		; get new file length and new start claster
		;
	LD	L,(IY+FIFO_DIRCL+0)
	LD	H,(IY+FIFO_DIRCL+1)
	LD	(DIRCL),HL
	LD	L,(IY+FIFO_DIRPOS+0)
	LD	H,(IY+FIFO_DIRPOS+1)
	LD	(DIRPOS),HL
		;

	CALL	READ_DIRFILE

		;
	LD	BC,001AH
	ADD	HL,BC

	CALL	SETFILEPARA2

	LD	A,(IY+FIFO_CMTLEN+0)
	LD	(IY+FIFO_CMTPTR+0),A
	LD	A,(IY+FIFO_CMTLEN+1)
	LD	(IY+FIFO_CMTPTR+1),A
	LD	A,(IY+FIFO_CMTLEN+2)
	LD	(IY+FIFO_CMTPTR+2),A
	LD	A,(IY+FIFO_CMTLEN+3)
	LD	(IY+FIFO_CMTPTR+3),A

	CALL	FILETAILREAD

	LD	A,06H
	LD	(REG_CMTWR),A
	LD	A,04H
	LD	(REG_CMTWR),A

	LD	L,(IY+FIFO_CL+0)
	LD	H,(IY+FIFO_CL+1)

	LD	A,L
	OR	H
	JR	NZ,CWWL0

		;
		; file length = 0
		;
	CALL	GET_NEWCL

	LD	(IY+FIFO_CL+0),L
	LD	(IY+FIFO_CL+1),H
	LD	(IY+FIFO_STCL+0),L
	LD	(IY+FIFO_STCL+1),H

	LD	DE,0FFFFH
	CALL	FATWRITE

	JR	CWWL1

CWWL0:
	LD	DE,0FFF8H
	OR	A
	SBC	HL,DE
	JR	C,CWWL1

		;
		; file length % (200H x FATSEC) = 0
		;
	CALL	GET_NEWCL

	LD	(IY+FIFO_CL+0),L
	LD	(IY+FIFO_CL+1),H

	PUSH	HL
	LD	DE,0FFFFH
	CALL	FATWRITE
		;
	POP	HL
	EX	DE,HL
	LD	L,(IY+FIFO_BEFCL+0)
	LD	H,(IY+FIFO_BEFCL+1)
	CALL	FATWRITE

CWWL1:

	LD	A,0CH
	LD	(REG_BUFSEL),A

	LD	A,05H
	LD	(REG_CMTWR),A
	DEC	A
	LD	(REG_CMTWR),A

	LD	A,02H
	LD	(WRITEFLAG),A


	RET


		;
		; WRITEFLAG = 2
		;
CWW_FL2:
	LD	A,01H
	LD	(REG_BUFAD),A
	LD	IY,REG_FIFO_1

	LD	A,(REG_CMTOPEN)
	AND	02H
	JR	Z,CWWL2

	LD	A,(REG_CMTWR)
	AND	10H

		;
		; saveopen = 1 and wrfull = 0
		; no process
		;
	RET	Z

		;
		; saveopen = 1 and wrfull = 1
		;

		;
		; write 1 sector
		;
	LD	L,(IY+FIFO_CL+0)
	LD	H,(IY+FIFO_CL+1)
	LD	A,(IY+FIFO_SEC)
	CALL	CALCSDADD
		;
	LD	HL,WORK
	CALL	LD4B_REG_SDADD_MHL
		;
	CALL	WRITE1SEC

		;
		; new sector
		;
	LD	L,(IY+FIFO_CL+0)
	LD	H,(IY+FIFO_CL+1)
	LD	A,(IY+FIFO_SEC)
	PUSH	HL
	CALL	GET_NEWSEC
	LD	(IY+FIFO_CL+0),L
	LD	(IY+FIFO_CL+1),H
	LD	(IY+FIFO_SEC),A

	POP	HL
	OR	A
	JR	NZ,CWWL11
		;

	LD	(IY+FIFO_BEFCL+0),L
	LD	(IY+FIFO_BEFCL+1),H
		;
	LD	L,(IY+FIFO_CL+0)
	LD	H,(IY+FIFO_CL+1)
	LD	DE,0FFFFH
	CALL	FATWRITE
		;
	LD	E,(IY+FIFO_CL+0)
	LD	D,(IY+FIFO_CL+1)
	LD	L,(IY+FIFO_BEFCL+0)
	LD	H,(IY+FIFO_BEFCL+1)

	CALL	FATWRITE

CWWL11:
	LD	A,0CH
	LD	(REG_BUFSEL),A

	LD	A,05H
	LD	(REG_CMTWR),A
	DEC	A
	LD	(REG_CMTWR),A

	RET

CWWL2:
	LD	A,(REG_CMTWR)
	AND	10H
	JR	NZ,CWWL3

		;
		; saveopen = 0 and wrfull = 0
		;

	LD	A,(IY+FIFO_WRADD+1)
	AND	01H
	OR	(IY+FIFO_WRADD+0)

		;
		; cmtwradd(8:0) <> 0
		;
	JR	NZ,CWWL3

	LD	A,(IY+FIFO_SEC)
	OR	A

		;
		; (IY+FIFO_SEC) <> 0
		;
	JR	NZ,CWWL4

		;
		; (IY+FIFO_SEC) = 0
		;

		; FAT rewind

	CALL	SDADDINIT

	LD	L,(IY+FIFO_CL+0)
	LD	H,(IY+FIFO_CL+1)
	LD	DE,0000H

	CALL	FATWRITE

	LD	L,(IY+FIFO_BEFCL+0)
	LD	H,(IY+FIFO_BEFCL+1)
	LD	A,L
	OR	H

	JR	Z,CWWL4

	LD	DE,0FFFFH
	CALL	FATWRITE

	JR	CWWL4


CWWL3:
		;
		; saveopen = 0 and wrfull = 1
		;

		;
		; write 1 sector
		;
	LD	L,(IY+FIFO_CL+0)
	LD	H,(IY+FIFO_CL+1)
	LD	A,(IY+FIFO_SEC)
	CALL	CALCSDADD
		;
	LD	HL,WORK
	CALL	LD4B_REG_SDADD_MHL
		;

	CALL	WRITE1SEC

CWWL4:
		;
		; file length and claster overwrite
		;
	XOR	A
	OR	(IY+FIFO_WRADD+0)
	OR	(IY+FIFO_WRADD+1)
	OR	(IY+FIFO_WRADD+2)
	OR	(IY+FIFO_WRADD+3)
	JR	NZ,CWWL5

		;
		; file length = 0 -> claster = 0
		;
	XOR	A
	LD	(IY+FIFO_STCL+0),A
	LD	(IY+FIFO_STCL+1),A

CWWL5:
	LD	L,(IY+FIFO_DIRCL+0)
	LD	H,(IY+FIFO_DIRCL+1)
	LD	(DIRCL),HL
	LD	L,(IY+FIFO_DIRPOS+0)
	LD	H,(IY+FIFO_DIRPOS+1)
	LD	(DIRPOS),HL

	CALL	READ_DIRFILE

	LD	A,09H
	LD	(REG_BUFSEL),A

	LD	DE,001AH
	ADD	HL,DE
		;
	LD	A,(IY+FIFO_STCL+0)
	LD	(HL),A
	INC	HL
	LD	A,(IY+FIFO_STCL+1)
	LD	(HL),A
	INC	HL
		;
	LD	A,(IY+FIFO_WRADD+0)
	LD	(HL),A
	INC	HL
	LD	A,(IY+FIFO_WRADD+1)
	LD	(HL),A
	INC	HL
	LD	A,(IY+FIFO_WRADD+2)
	LD	(HL),A
	INC	HL
	LD	A,(IY+FIFO_WRADD+3)
	LD	(HL),A

	CALL	WRITE1SEC

	XOR	A
	LD	(REG_SDCTRL),A
	INC	A
	LD	(REG_BUFSEL),A
	LD	(WRITEFLAG),A
	RET


;
; file read from any position within 512 bytes
; (REG_BUFAD) <= use FIFO number
; (IY+FIFO_CMTLEN) <= file length
; (IY+FIFO_CMTPTR) <= read start position
; (P6TBUFFER) <= key data buffer
; IY <= use FIFO number
; A  <= read length
;
; RETURN
; A <= read length
;
FILEPOSREAD:
		;
		; HLDE <= (IY+CMTLEN) - (IY+CMTPTR)
		;
	OR	A
	LD	L,(IY+FIFO_CMTLEN+0)
	LD	H,(IY+FIFO_CMTLEN+1)
	LD	C,(IY+FIFO_CMTPTR+0)
	LD	B,(IY+FIFO_CMTPTR+1)
	SBC	HL,BC
	EX	DE,HL
	LD	L,(IY+FIFO_CMTLEN+2)
	LD	H,(IY+FIFO_CMTLEN+3)
	LD	C,(IY+FIFO_CMTPTR+2)
	LD	B,(IY+FIFO_CMTPTR+3)
	SBC	HL,BC

	JR	NC,FPOSL_OK

	LD	B,00H
	PUSH	BC
	JR	FPOSL_ED

FPOSL_OK:
	PUSH	AF
	XOR	A
	OR	H
	OR	L
	OR	D
	POP	BC
	JR	NZ,FPOSL0

	LD	A,E
	CP	B
	JR	NC,FPOSL0

	LD	B,E

	LD	A,B
	OR	A
	JR	NZ,FPOSL0

	PUSH	BC
	JR	FPOSL_ED

FPOSL0:
	LD	A,01H
	LD	(REG_SDCTRL),A

	PUSH	BC
	PUSH	BC

	CALL	FILETAILREAD

	LD	L,(IY+FIFO_CMTPTR+0)
	LD	A,(IY+FIFO_CMTPTR+1)
	AND	01H
	LD	H,A
	LD	DE,REG_SDBUF
	ADD	HL,DE
		;
	LD	DE,P6TBUFFER
		;
	LD	A,01H
	LD	(IY+FIFO_FATNEW),A

	POP	BC
FPOSL1:
	PUSH	BC
	LD	A,H
	AND	01H
	OR	L
	JR	NZ,FPOSL2

	PUSH	DE

	LD	A,(IY+FIFO_FATNEW)
	OR	A
	LD	L,(IY+FIFO_CL+0)
	LD	H,(IY+FIFO_CL+1)
	LD	A,(IY+FIFO_SEC)
	CALL	Z,GET_NEXTSEC
		;

	CALL	CALCSDADD
		;
	LD	HL,WORK
	CALL	LD4B_REG_SDADD_MHL
	CALL	READ1SEC

	POP	DE
	LD	HL,REG_SDBUF

FPOSL2:
	XOR	A
	LD	(IY+FIFO_FATNEW),A
		;
	LD	A,(HL)
	LD	(DE),A
		;
	INC	HL
	INC	DE

	POP	BC
	DJNZ	FPOSL1

FPOSL_ED:
	XOR	A
	LD	(REG_SDCTRL),A
	LD	(IY+FIFO_SEC),A

	LD	A,(IY+FIFO_STCL+0)
	LD	(IY+FIFO_CL+0),A
	LD	A,(IY+FIFO_STCL+1)
	LD	(IY+FIFO_CL+1),A

	LD	HL,REG_CMTRD
	LD	(HL),02H
	LD	(HL),00H

	POP	AF
	RET


;
; 1 sector read from file tail
; (REG_BUFAD) <= use FIFO number
; (IY+FIFO_CMTPTR) <= read length
; IY <= use FIFO number
;
; RETURN :
; (IY+CL),(IY+SEC) <= next sector
; (IY+BEFCL)       <= before claster
; 
; (IY+CL),(IY+BEFCL) = 0000H
; -> file length = 0  (and not read 1 sector)
;
; (IY+CL) >= FFF8H
; -> file length % 200H = 0  (and not read 1 sector)
;

FILETAILREAD:
	LD	A,(IY+FIFO_STCL+0)
	LD	(IY+FIFO_CL+0),A
	LD	A,(IY+FIFO_STCL+1)
	LD	(IY+FIFO_CL+1),A
	XOR	A
	LD	(IY+FIFO_SEC),A
	LD	(IY+FIFO_BEFCL+0),A
	LD	(IY+FIFO_BEFCL+1),A
	LD	HL,0000H
	LD	(WORK4+0),HL
	LD	(WORK4+2),HL

FDRL2:
		;
		; CP (IY+FIFO_CMTPTR)-(WORK4)
		;
	PUSH	IY
	POP	HL
	LD	E,FIFO_CMTPTR
	LD	D,00H
	ADD	HL,DE
	PUSH	HL
		;
	LD	DE,WORK4
	LD	B,04H
	CALL	CP_MHL_MDE
	POP	HL

	RET	Z

	PUSH	HL

		;
		; (WORK4) = (WORK4) + 0200H
		;
	LD	HL,0200H
	LD	(WORK+0),HL
	LD	HL,0000H
	LD	(WORK+2),HL
	LD	DE,WORK
	LD	HL,WORK4
	CALL	ADD4B_MHL_MDE

		;
		; CP (IY+FIFO_CMTPTR)-(WORK4)
		;
	POP	HL
	LD	DE,WORK4
	LD	B,04H
	CALL	CP_MHL_MDE
	JR	C,FDRL_END

		;
		; sector ++
		;
	LD	L,(IY+FIFO_CL+0)
	LD	H,(IY+FIFO_CL+1)
	LD	A,(IY+FIFO_SEC)
	PUSH	HL
	CALL	GET_NEXTSEC
	LD	(IY+FIFO_CL+0),L
	LD	(IY+FIFO_CL+1),H
	LD	(IY+FIFO_SEC),A
		;
	POP	HL
	OR	A
	JR	NZ,FDRL2
		;
	LD	(IY+FIFO_BEFCL+0),L
	LD	(IY+FIFO_BEFCL+1),H
		;
	JR	FDRL2


FDRL_END:
		;
		; read 1 sector of file end
		;
	LD	L,(IY+FIFO_CL+0)
	LD	H,(IY+FIFO_CL+1)
	LD	A,L
	OR	H
	JP	Z,SDERR
	LD	A,(IY+FIFO_SEC)
	CALL	CALCSDADD
		;
	LD	HL,WORK
	CALL	LD4B_REG_SDADD_MHL
		;
	CALL	READ1SEC
		;
	RET

;
; ROM file read
; IX <= file name address
; HL <= ROM start address+0
; DE <= ROM start address+2
;
ROMFILEREAD:
	XOR	A
	LD	(REG_BUFAD),A
	LD	IY,REG_FIFO_0
	LD	A,05H
	LD	(FILESEL),A

	PUSH	IX
	PUSH	HL
	PUSH	DE

	LD	IX,F_ROMDIR
	LD	A,10H
	LD	(SEARCHTYPE),A
	LD	HL,0000H
	LD	(DIRCL),HL
	CALL	FILESEARCH

	POP	DE
	POP	HL
	POP	IX

	LD	A,(IY+FIFO_CL+0)
	LD	(DIRCL+0),A
	LD	A,(IY+FIFO_CL+1)
	LD	(DIRCL+1),A

	LD	(IY+FIFO_CMTPTR+0),L
	LD	(IY+FIFO_CMTPTR+1),H
	LD	(IY+FIFO_CMTPTR+2),E
	LD	(IY+FIFO_CMTPTR+3),D
		;
	XOR	A
	LD	(SEARCHTYPE),A
	CALL	FILESEARCH
	CALL	FILEREAD
		;
	RET

;
; file read
; (REG_BUFAD) <= use FIFO number
; (FILESEL) <= FIFO type
; IY <= use FIFO number
;
FILEREAD:
	LD	A,01H
	LD	(REG_SDCTRL),A
	LD	A,(FILESEL)
	LD	(REG_BUFSEL),A
	LD	HL,REG_CMTRD
	LD	(HL),02H
	LD	(HL),00H
		;
FRL1:	LD	L,(IY+FIFO_CL+0)
	LD	H,(IY+FIFO_CL+1)
	LD	A,L
	OR	H
	JP	Z,SDERR
	LD	A,(IY+FIFO_SEC)
	CALL	CALCSDADD
		;
	LD	HL,WORK
	CALL	LD4B_REG_SDADD_MHL
		;

	CALL	READ1SEC
		;
READCONT:
	LD	A,01H
	LD	(REG_SDCTRL),A
	LD	A,(FILESEL)
	LD	(REG_BUFSEL),A
	LD	A,01H
	LD	(REG_CMTRD),A
		;
FRL3:	LD	A,(FILESEL)
	CP	05H
	JR	Z,FRL2
	LD	A,(REG_CMTOPEN)
	AND	01H
	JR	Z,FRL4
FRL2:	LD	A,(REG_CMTRD)
	BIT	5,A
	JR	NZ,FRL4
	BIT	4,A
	JR	Z,FRL3
		;
	XOR	A
	LD	(REG_CMTRD),A
		;
	LD	L,(IY+FIFO_CL+0)
	LD	H,(IY+FIFO_CL+1)
	LD	A,(IY+FIFO_SEC)
	CALL	GET_NEXTSEC
	LD	(IY+FIFO_CL+0),L
	LD	(IY+FIFO_CL+1),H
	LD	(IY+FIFO_SEC),A
		;
	JR	FRL1
		;
FRL4:	XOR	A
	LD	(REG_CMTRD),A
	LD	(REG_SDCTRL),A
	RET

;
; rom file seaech in root directory
; (REG_BUFAD) <= use FIFO number
; IX <= file name address
; IY <= use FIFO number
;
; RETURN
; (IY+FIFO_CMTLEN) <= file length
; (IY+FIFO_CL)     <= file claster number
; (IY+FIFO_SEC)    <= file sector number
; (IY+FIFO_STCL)   <= file start claster number
; (IY+FIFO_DIRCL)  <= file claster in directory
; (IY+FIFO_DIRPOS) <= file position in directory
;
FILESEARCH:
	LD	A,01H
	LD	(REG_SDCTRL),A
	LD	HL,0000H
	LD	(DIRPOS),HL
	CALL	SDADDINIT
		;
FSL1:	CALL	READ_DIRFILE
		;
	LD	A,(HL)
	OR	A
	JP	Z,SDERR
	PUSH	IX
	POP	DE
	PUSH	HL
	LD	B,0BH
	CALL	CP_MHL_MDE
	POP	HL
	JR	NZ,FSL11
	LD	BC,000BH
	ADD	HL,BC
	LD	A,(HL)
	AND	1EH
	LD	B,A
	LD	A,(SEARCHTYPE)
	CP	B
	JR	Z,FSL2
		;
FSL11:	LD	HL,(DIRPOS)
	INC	HL
	LD	(DIRPOS),HL
	LD	A,H
	CP	02H
	JP	NC,SDERR
	JR	FSL1
		;
FSL2:	LD	BC,000FH
	ADD	HL,BC
	
	CALL	SETFILEPARA

		;
	XOR	A
	LD	(IY+FIFO_SEC),A
	LD	(REG_SDCTRL),A
	RET

;
; rom area initialize
;
ROMINIT:
	LD	HL,REG_ROMINIT
	LD	(HL),01H
	DEC	(HL)
ROMLP:	LD	A,(HL)
	OR	A
	JR	NZ,ROMLP
	RET

;
; SD card initialized and read parameter
; use #0 FIFO (REG_BUFAD = 00H)
;
SDCARD_OPEN:
	LD	HL,REG_SDCTRL
	LD	(HL),01H
	XOR	A
	LD	(REG_BUFAD),A
;
; command 0 (S/W reset)
;
	LD	HL,0000H
	LD	(REG_SDADD),HL
	LD	(REG_SDADD+2),HL
	XOR	A
	CALL	SENDCMD2
;
; command 1 (idle detect)
;
SDW1:	LD	A,01H
	CALL	SENDCMD2
	BIT	1,(HL)
	JR	NZ,SDW1
;
; command 16 (length set)
;
	LD	A,10H
	CALL	SENDCMD
;
; read phisical sector #0
;
	CALL	READ1SEC
	LD	HL,REG_OFFSET
	LD	DE,OFFSET
	CALL	LD4B_MDE_MHL
;
; read logical sector #0 (read BPB parameter)
;
	LD	HL,OFFSET
	CALL	LD4B_REG_SDADD_MHL
	CALL	READ1SEC
	CALL	CHKSPT
		;
		; claster size = BPB_CLASTSEC
		;
	LD	A,(BPB_CLASTSEC)
	LD	(CLASTSIZE),A
		;
		; FAT start = OFFSET + BPB_FATST
		;
	LD	HL,(OFFSET)
	LD	DE,(BPB_FATST)
	ADD	HL,DE
	LD	(FATST),HL
	LD	HL,(OFFSET+2)
	LD	DE,0000H
	ADC	HL,DE
	LD	(FATST+2),HL
;		;
;		; root directory start = FATST + BPB_FATNUM x BPB_FATSEC
;		;
;	LD	DE,ROOTST
;	LD	HL,FATST
;	CALL	LD4B_MDE_MHL
;	LD	HL,(BPB_FATSEC)
;	LD	(WORK),HL
;	LD	HL,0000H
;	LD	(WORK+2),HL
;
;	LD	A,(BPB_FATNUM)
;	LD	B,08H
;RDLP1:	RRCA
;	PUSH	AF
;	PUSH	BC
;	JR	NC,RDLP2
;	LD	HL,ROOTST
;	LD	DE,WORK
;	CALL	ADD4B_MHL_MDE
;		;
;RDLP2:	LD	HL,WORK
;	CALL	SHT4B_MHL
;		;
;	POP	BC
;	POP	AF
;	DJNZ	RDLP1
		;
		; FAT use sector number = BPB_FATSEC
		;
	LD	HL,(BPB_FATSEC)
	LD	(FATSEC),HL
		;
		; root directory start = FATST + BPB_FATNUM(=02H) x FATSEC
		;
	LD	DE,ROOTST
	LD	HL,FATST
	CALL	LD4B_MDE_MHL
	LD	HL,(FATSEC)
	LD	(WORK),HL
	LD	HL,0000H
	LD	(WORK+2),HL
	LD	HL,WORK
	CALL	SHT4B_MHL
	LD	HL,ROOTST
	LD	DE,WORK
	CALL	ADD4B_MHL_MDE
		;
		; claster start = ROOTST + 32
		;
	LD	HL,ROOTST
	LD	DE,CLASTST
	CALL	LD4B_MDE_MHL
	LD	HL,CLASTST
	LD	A,20H
	CALL	ADD4B_MHL_A
		;
	XOR	A
	LD	(REG_SDCTRL),A
		;
	RET



;
; directory file list read
; (REG_BUFAD) <= use FIFO number
; (DIRCL)     <= claster number of directory claster (0000H = root)
; (DIRPOS)    <= file position in directory
;
; RETURN
; HL:file pointer address
;
READ_DIRFILE:
	LD	HL,(DIRPOS)
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	B,H
	LD	HL,(DIRCL)
	LD	A,H
	OR	L
	JR	NZ,RDL1
		;
		; root directory
		;
	LD	HL,ROOTST
	PUSH	BC
	CALL	LD4B_WORK_MHL
	POP	BC
	LD	A,B
	LD	HL,WORK
	CALL	ADD4B_MHL_A
	JR	RDL2
		;
		;
RDL1:	XOR	A
	INC	B
		;
RDL3:	DEC	B
	JR	Z,RDL4
	PUSH	BC
	CALL	GET_NEXTSEC
	POP	BC
	JR	RDL3
		;
RDL4:	CALL	CALCSDADD
		;
RDL2:	LD	HL,WORK
	LD	DE,REG_SDADD
	LD	B,04H
	CALL	CP_MHL_MDE
	JR	Z,RDL5
		;
	LD	HL,WORK
	CALL	LD4B_REG_SDADD_MHL
	CALL	READ1SEC
		;
RDL5:	LD	A,(DIRPOS)
	AND	0FH
	LD	L,A
	LD	H,00H
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	DE,REG_SDBUF
	ADD	HL,DE
	RET


;
; claster and sector number -> SD address
;
; SD address <= CLASTST + CLASTSIZE x (claster - 2) + sector
; (REG_BUFAD) <= use FIFO number
; HL : claster number
; A  : sector number
;
; RETURN : (WORK) <- SD address
;
CALCSDADD:
	CALL	CLASTCHECK
	DEC	HL
	DEC	HL
	LD	(WORK2),HL
	LD	HL,0000H
	LD	(WORK2+2),HL
		;
	LD	HL,CLASTST
	CALL	LD4B_WORK_MHL
	LD	HL,WORK
	CALL	ADD4B_MHL_A
		;	
	LD	A,(CLASTSIZE)
	LD	B,08H
CSAL2:	RRCA
	PUSH	AF
	PUSH	BC
	JR	NC,CSAL1
	LD	HL,WORK
	LD	DE,WORK2
	CALL	ADD4B_MHL_MDE
		;
CSAL1:	LD	HL,WORK2
	CALL	SHT4B_MHL
		;
	POP	BC
	POP	AF
	DJNZ	CSAL2
		;
	RET


;
; get next sector
; (REG_BUFAD) <= use FIFO number
; HL : claster number
; A  : sector number
;
; RETURN
; HL <= next claster number
; A  <= next sector number
;
GET_NEXTSEC:
	CALL	CLASTCHECK
	LD	C,A
	INC	C
	LD	A,(CLASTSIZE)
	LD	B,A
	LD	A,C
	CP	B
	RET	C
		;
	CALL	GET_NEXTCL
	XOR	A
	RET

;
; get next claster number from FAT
; (REG_BUFAD) <= use FIFO number
; HL : claster number
;
; RETURN : HL <= next claster number
;
GET_NEXTCL:
	CALL	CLASTCHECK

	PUSH	HL
	CALL	SDADDINIT
	POP	HL
	XOR	A
	CALL	CALCFATADD	

	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL
	RET

;
; claster number check
; HL : claster number
;
CLASTCHECK:
	PUSH	HL
	PUSH	DE
	LD	DE,0FFF7H
	OR	A
	SBC	HL,DE
	JP	NC,SDERR
	POP	DE
	POP	HL
	RET

;
; get new sector
; (REG_BUFAD) <= use FIFO number
; HL : claster number
; A  : sector number
;
; RETURN
; HL <= next claster number
; A  <= next sector number
;
GET_NEWSEC:
	CALL	CLASTCHECK
	LD	C,A
	INC	C
	LD	A,(CLASTSIZE)
	LD	B,A
	LD	A,C
	CP	B
	RET	C
		;
	CALL	GET_NEWCL
	XOR	A
	RET

;
; get new claster number from FAT
; (REG_BUFAD) <= use FIFO number
;
; RETURN : HL <= next claster number
;
GET_NEWCL:
	CALL	SDADDINIT
	LD	HL,0000H

GNCL_LP:
	PUSH	HL

	XOR	A
	CALL	CALCFATADD
		;
	LD	E,(HL)
	INC	HL
	LD	A,(HL)
	OR	E
	POP	HL

	JR	NZ,GNCL_NG

	PUSH	HL

	LD	A,01H
	CALL	CALCFATADD
		;
	LD	E,(HL)
	INC	HL
	LD	A,(HL)
	OR	E
	POP	HL

	RET	Z

GNCL_NG:
	INC	HL
	EX	DE,HL

	LD	HL,(FATSEC)
	LD	H,L
	LD	L,00H
	ADD	HL,HL

	OR	A
	SBC	HL,DE
	EX	DE,HL

	JP	NC,GNCL_LP

	JP	SDERR


;
; FAT overwrite
; (REG_BUFAD) <= use FIFO number
; HL <= claster number
; DE <= new data
;
FATWRITE:
	CALL	CLASTCHECK

	PUSH	DE
	PUSH	HL
	PUSH	DE
	PUSH	HL

	CALL	SDADDINIT
	POP	HL
	XOR	A
	CALL	CALCFATADD
		;

	LD	A,09H
	LD	(REG_BUFSEL),A
		;
	POP	DE
	LD	(HL),E
	INC	HL
	LD	(HL),D
		;
	LD	A,01H
	LD	(REG_BUFSEL),A
		;

	CALL	WRITE1SEC

	POP	HL
		;
	LD	A,01H
	CALL	CALCFATADD
		;
	LD	A,09H
	LD	(REG_BUFSEL),A
		;
	POP	DE
	LD	(HL),E
	INC	HL
	LD	(HL),D
		;
	LD	A,01H
	LD	(REG_BUFSEL),A
		;

	CALL	WRITE1SEC


	RET

;
; FAT address calculate
; (REG_BUFAD) <= use FIFO number
; HL <= claster number
; A  <= 1:FAT#2 0:FAT#1
;
; RETURN
; HL <= FAT address
;
CALCFATADD:
	PUSH	HL
	PUSH	AF
	PUSH	HL

	LD	DE,WORK3
	LD	HL,REG_SDADD
	CALL	LD4B_MDE_MHL

		;
		; SDADD <= FATST + claster number / 16 (+ FATSEC)
		;
	LD	HL,FATST
	CALL	LD4B_REG_SDADD_MHL
	POP	HL
	LD	A,H
	LD	HL,REG_SDADD
	CALL	ADD4B_MHL_A
	POP	AF
	OR	A
	JR	Z,CFAL1
		;
	LD	HL,(FATSEC)
	LD	(WORK+0),HL
	LD	HL,0000H
	LD	(WORK+2),HL
	LD	DE,WORK
	LD	HL,REG_SDADD
	CALL	ADD4B_MHL_MDE
CFAL1:
		;
	LD	HL,WORK3
	LD	DE,REG_SDADD
	LD	B,04H
	CALL	CP_MHL_MDE
		;
	CALL	NZ,READ1SEC
		;
	POP	HL
	LD	H,00H
	ADD	HL,HL
	LD	DE,REG_SDBUF
	ADD	HL,DE

	RET

;
; (HL)x4b <- (HL)x4b + (DE)x4b
;
ADD4B_MHL_MDE:
	LD	A,(DE)
	ADD	A,(HL)
	LD	(HL),A
	INC	DE
	INC	HL
	LD	A,(DE)
	ADC	A,(HL)
	LD	(HL),A
	INC	DE
	INC	HL
	LD	A,(DE)
	ADC	A,(HL)
	LD	(HL),A
	INC	DE
	INC	HL
	LD	A,(DE)
	ADC	A,(HL)
	LD	(HL),A
	RET


;
; (HL)x4b <- (HL)x4b + A
;
ADD4B_MHL_A:
	ADD	A,(HL)
	LD	(HL),A
	INC	HL
	LD	A,00H
	ADC	A,(HL)
	LD	(HL),A
	INC	HL
	LD	A,00H
	ADC	A,(HL)
	LD	(HL),A
	INC	HL
	LD	A,00H
	ADC	A,(HL)
	LD	(HL),A
	RET


;
; (HL)x4b <- (HL)x4b x 2
;
SHT4B_MHL:
	OR	A
	LD	A,(HL)
	RLA
	LD	(HL),A
	INC	HL
	LD	A,(HL)
	RLA
	LD	(HL),A
	INC	HL
	LD	A,(HL)
	RLA
	LD	(HL),A
	INC	HL
	LD	A,(HL)
	RLA
	LD	(HL),A
	RET


;
; CP (HL)-(DE) x B byte
;
; RETURN
; (HL) > (DE) : Cflag reset / Zflag reset
; (HL) = (DE) : Cflag reset / Zflag set
; (HL) < (DE) : Cflag set   / Zflag reset
;
CP_MHL_MDE:
	LD	A,B
CPL1:	INC	DE
	INC	HL
	DJNZ	CPL1
	LD	B,A

CPL2:	DEC	DE
	DEC	HL
	LD	A,(DE)
	CP	(HL)
	CCF
	RET	NZ
	DJNZ	CPL2
	XOR	A
	RET

;
; (DE)x4b <- (HL)x4b
;
LD4B_MDE_MHL:
	LD	BC,0004H
	LDIR
	RET

;
; (REG_SDADD)x4b <- (HL)x4b
;
LD4B_REG_SDADD_MHL:
	LD	DE,REG_SDADD
	LD	BC,0004H
	LDIR
	RET

;
; (WORK)x4b <- (HL)x4b
;
LD4B_WORK_MHL:
	LD	DE,WORK
	LD	BC,0004H
	LDIR
	RET


;
; read 1 sector
;
READ1SEC:
	LD	A,08H
	LD	(REG_BUFSEL),A
	LD	HL,REG_SDRD
	LD	(HL),01H
	DEC	(HL)
	LD	A,11H
	CALL	SENDCMD
RSL1:	LD	A,(REG_SDRD)
	AND	10H
	JR	Z,RSL1
	LD	A,01H
	LD	(REG_BUFSEL),A
	RET

;
; write 1 sector
;

WRITE1SEC:
	XOR	A
	LD	(REG_BUFSEL),A
	LD	HL,REG_SDWR
	LD	(HL),01H
	DEC	(HL)
	LD	A,18H
	CALL	SENDCMD
WSL1:	LD	A,(REG_SDWR)
	AND	10H
	JR	Z,WSL1

	LD	A,01H
	LD	(REG_BUFSEL),A
	RET



SENDCMD:
;
; Areg <= command_No
;
	LD	(REG_SDCMDNO),A
	LD	HL,REG_SDCMDST
	LD	(HL),01H
	DEC	(HL)
SCL1:	BIT	0,(HL)
	JR	NZ,SCL1
	LD	A,06H
	AND	(HL)
	JR	NZ,SDERR
	RET


SENDCMD2:
;
; Areg <= command_No
;
	LD	(REG_SDCMDNO),A
	LD	HL,REG_SDCMDST
	LD	(HL),01H
	DEC	(HL)
SCL2:	BIT	0,(HL)
	JR	NZ,SCL2
	BIT	2,(HL)
	JR	NZ,SDERR
	RET


CHKSPT:
;
; SD card support check
;
; FAT16
; # of FAT = 02H
; # of sector byte = 0200H
; # of root directory entry = 0200H

	LD	HL,(BPB_FATVER)
	LD	DE,3631H
	OR	A
	SBC	HL,DE
	JR	NZ,SDERR
		;
	LD	A,(BPB_FATNUM)
	CP	02H
	JR	NZ,SDERR
		;
	LD	HL,(BPB_SECBYTE)
	LD	DE,0200H
	OR	A
	SBC	HL,DE
	JR	NZ,SDERR
		;
	LD	HL,(BPB_DIRENTRY)
	OR	A
	SBC	HL,DE
	JR	NZ,SDERR
	RET


SDERR:
;
; SD card error
;
	LD	HL,REG_SDCTRL
	LD	A,02H
	LD	(HL),A
	LD	SP,INITSP
	LD	A,(SDMODE)
	OR	A
ERRLP:	JR	Z,ERRLP
	CP	01H
	JP	Z,MAINSTART
	JP	MAINST2
	JR	ERRLP

;
; LCD initialize
;
LCD_INIT:
	LD	DE,00300H
	CALL	LCD_OUTDT
	LD	DE,00001H
	CALL	LCD_OUTDT
	LD	DE,00002H
	CALL	LCD_OUTDT
	LD	DE,0CC03H
	CALL	LCD_OUTDT
	LD	DE,00007H
	CALL	LCD_OUTDT

	LD	A,01H
	LD	(REG_LCDDONE),A

	RET

;
; LCD setting data output
;
LCD_OUTDT:
	LD	HL,REG_LCDST
	LD	(REG_LCDADD),DE
	LD	(HL),01H
	XOR	A
LCDD1:	CP	(HL)
	JR	NZ,LCDD1
	RET

;
; SD registers and circuits initialize
;
SDREGINIT:
	CALL	SDREGINIT_0
	CALL	SDREGINIT_1
	CALL	SDREGINIT_2
		;
	LD	HL,REG_SDRD
	LD	(HL),01H
	LD	(HL),00H
		;
	LD	A,(REG_SDWP)
	LD	(SDWPFLAG),A
		;
	LD	HL,0000H
	LD	(SDDETTIMER),HL
		;
	LD	DE,ST_CMTREAD_VAL
	CALL	LD_ST_NOSELECT
	LD	DE,ST_CMTWRITE_VAL
	CALL	LD_ST_NOSELECT
		;
	LD	A,(REG_SDWP)
	OR	A
	RET	Z
		;
	LD	DE,ST_CMTWRITE_VAL
	LD	HL,ST_WRPROTECT
	LD	BC,000CH
	LDIR
		;
	RET

;
; SD registers and circuits initialize (#0:CMT load FIFO)
;
SDREGINIT_0:
	PUSH	HL
	LD	HL,REG_FIFO_0
	XOR	A
	LD	B,20H
SRL1_0:	LD	(HL),A
	INC	HL
	DJNZ	SRL1_0
		;
	LD	IY,REG_FIFO_0
		;
	LD	HL,REG_CMTRD
	LD	(HL),02H
	LD	(HL),00H
		;
	XOR	A
	LD	(READFLAG),A
	LD	(P6TCMDENB),A
	LD	(P6TCMDENBBEF),A
	LD	(P6TFILEREAD),A
		;
	POP	HL
	RET

;
; SD registers and circuits initialize (#1:CMT save FIFO)
;
SDREGINIT_1:
	PUSH	HL
	LD	HL,REG_FIFO_1
	XOR	A
	LD	B,20H
SRL1_1:	LD	(HL),A
	INC	HL
	DJNZ	SRL1_1
		;
	LD	IY,REG_FIFO_1
		;
	XOR	A
	LD	(REG_CMTWR),A
	LD	(WRITEFLAG),A
		;
	POP	HL
	RET

;
; SD registers and circuits initialize (#2:FDD FIFO)
;
SDREGINIT_2:
	PUSH	HL
	LD	HL,REG_FIFO_2
	XOR	A
	LD	B,20H
SRL1_2:	LD	(HL),A
	INC	HL
	DJNZ	SRL1_2
		;
	LD	IY,REG_FIFO_2
		;
	POP	HL
	RET


;
; copy "no select" string
;
LD_ST_NOSELECT:
	LD	HL,ST_NOSELECT
	LD	BC,000CH
	LDIR
	RET

;
; SD address initialize
;
SDADDINIT:
	LD	HL,0FFFFH
	LD	(REG_SDADD),HL
	LD	(REG_SDADD+2),HL
	RET

;
; function key buffer initialize
;
KEYBUFINIT:
	LD	HL,CTRLNOW
	XOR	A
	LD	B,0CH
KBL1:	LD	(HL),A
	INC	HL
	DJNZ	KBL1
	RET

;
; detect SD card insert or eject
;
DETSDEJECT:
	LD	A,(REG_SDWP)
	LD	B,A
	LD	A,(SDWPFLAG)
	XOR	B
	JR	Z,DSEL1

		;
		; detected SD card insert / eject
		;
	LD	A,(REG_SDWP)
	LD	(SDWPFLAG),A
		;
	LD	HL,1000H
	LD	(SDDETTIMER),HL
	RET

DSEL1:
	LD	HL,(SDDETTIMER)
	LD	A,H
	OR	L
	RET	Z

	DEC	HL
	LD	(SDDETTIMER),HL
	LD	A,H
	OR	L
	RET	NZ

		;
		; timer full
		;
	CALL	SDCARD_OPEN
	CALL	SDREGINIT

	LD	A,01H
	LD	(PAGEREDRAW),A
		;

	RET


;
; p6t format auto command input
;
P6TKEYWAIT:
	LD	A,(P6TCMDENBBEF)
	LD	C,A
	LD	A,(P6TCMDENB)
	LD	B,A
	LD	(P6TCMDENBBEF),A

	LD	A,(P6TFILEREAD)
	OR	A
	RET	Z

	LD	A,B
	OR	A
	LD	A,C
	JR	NZ,P6L1

	OR	A
	RET	Z

		;
		; auto mode -> manual mode
		;
	LD	HL,0000H
	LD	(KEYTIMER),HL

	LD	A,(READFLAG)
	OR	A
	RET	Z

	LD	HL,(REG_FIFO_0+FIFO_STCL)
	LD	(REG_FIFO_0+FIFO_CL),HL
	XOR	A
	LD	(REG_FIFO_0+FIFO_SEC),A
	INC	A
	LD	(READFLAG),A

	LD	HL,REG_CMTRD
	LD	(HL),02H
	LD	(HL),00H

	RET

P6L1:
	OR	A
	JR	NZ,P6L2

		;
		; manual mode -> auto mode
		;

	LD	HL,1000H
	LD	(KEYTIMER),HL
	XOR	A
	LD	(P6TKEYPUSH),A
	LD	A,05H
	LD	(P6TBUFPOS),A

	RET

P6L2:		;
		; auto mode
		;
		; judge command finish
		;
	LD	A,(P6TCMDLEN)
	LD	B,A
	LD	A,(P6TBUFPOS)
	CP	B
	RET	NC

		;
		; judge timer full and CMT read end
		;
	LD	HL,(KEYTIMER)
	LD	A,H
	OR	L
	JR	Z,P6LPUSH

	DEC	HL
	LD	(KEYTIMER),HL
	RET

P6LPUSH:
	LD	A,(P6TKEYPUSH)
	OR	A
	JR	NZ,P6LRELEASE

	CALL	GETKEYP6T
	LD	(REG_KEYDAT),A
	LD	(KEYTIMER),HL

	LD	A,01H
	LD	(P6TKEYPUSH),A
	LD	(REG_KEYENB),A

	RET

P6LRELEASE:
	CALL	GETKEYP6T
	EX	DE,HL
	LD	(KEYTIMER),HL
	LD	A,B
	LD	(P6TBUFPOS),A

	XOR	A
	LD	(P6TKEYPUSH),A
	LD	(REG_KEYENB),A

	RET

;
; get key data and stroke interval from buffer
;
; (P6TBUFFER) <= key data buffer
; (P6TBUFPOS) <= buffer position
;
; RETURN
; A  <= push key data
; HL <= key push wait timer
; DE <= key release wait timer
; B  <= next buffer position
;
GETKEYP6T:
	LD	A,(P6TBUFPOS)
	LD	E,A
	LD	D,00H
	LD	HL,P6TBUFFER
	ADD	HL,DE
	LD	A,(HL)
	LD	C,A

	LD	A,(P6TBUFPOS)
	CP	05H
	JR	NZ,GKPL1

		;
		; BASIC MODE
		;
	LD	A,(REG_MK2MODE)
	OR	A
	JR	NZ,GKPL_MK2

	LD	A,C
	OR	A
	JR	Z,GKPL0
	CP	05H
	JR	NC,GKPL0

	AND	01H
	LD	(REG_MEM16K),A
		;
	LD	HL,REG_CTRLRST
	LD	(HL),01H
	LD	(HL),00H

GKPL0:
	LD	B,06H
	LD	HL,0100H
	LD	DE,1000H
	XOR	A
	RET

GKPL_MK2:
	LD	B,06H
	LD	A,C
	ADD	A,30H
	LD	HL,0100H
	LD	DE,1000H
	RET

GKPL1:
	CP	06H
	JR	NZ,GKPL2
		;
		; Pages
		;
	LD	B,07H
	LD	A,C
	ADD	A,30H
	LD	HL,0100H
	LD	DE,0100H
	RET

GKPL2:
	CP	07H
	JR	NZ,GKPL3
		;
		; Pages (return)
		;
	LD	B,09H
	LD	A,0DH
	LD	HL,0100H
	LD	DE,2000H
	RET

GKPL3:
	LD	B,A
	INC	B
	LD	HL,0100H
	LD	DE,0100H

	LD	A,0AH
	CP	C
	JR	NZ,GKPL4

	LD	DE,1000H
	LD	A,0DH
	RET

GKPL4:
	LD	A,0DH
	CP	C
	JR	NZ,GKPL5
	LD	DE,1000H
GKPL5:
	LD	A,C
	RET

;
; read auto command from p6t file
;
; RETURN
; A <= P6T flag (01H:auto command 00H:no command)
; (P6TBUFFER) <= key data buffer
; (P6TCMDLEN) <= command length
;
READP6T:

		;
		; (IY+CMTPTR) <= (IY+CMTLEN) - 4
		;
	LD	A,(IY+FIFO_CMTLEN+0)
	SUB	04H
	LD	(IY+FIFO_CMTPTR+0),A
	LD	A,(IY+FIFO_CMTLEN+1)
	SBC	A,00H
	LD	(IY+FIFO_CMTPTR+1),A
	LD	A,(IY+FIFO_CMTLEN+2)
	SBC	A,00H
	LD	(IY+FIFO_CMTPTR+2),A
	LD	A,(IY+FIFO_CMTLEN+3)
	SBC	A,00H
	LD	(IY+FIFO_CMTPTR+3),A

	LD	A,04H
	CALL	FILEPOSREAD
	OR	A
	JR	Z,RP6T_NG

	LD	HL,P6TBUFFER
	LD	A,(HL)
	LD	(IY+FIFO_CMTPTR+0),A
	INC	HL
	LD	A,(HL)
	LD	(IY+FIFO_CMTPTR+1),A
	INC	HL
	LD	A,(HL)
	LD	(IY+FIFO_CMTPTR+2),A
	INC	HL
	LD	A,(HL)
	LD	(IY+FIFO_CMTPTR+3),A

	LD	A,4AH
	CALL	FILEPOSREAD
	OR	A
	JR	Z,RP6T_NG

	LD	HL,P6TBUFFER
		;
		; 0000H identify0 = "P"
		;
	LD	A,(HL)
	CP	"P"
	JR	NZ,RP6T_NG

		;
		; 0001H identify1 = "6"
		;
	INC	HL
	LD	A,(HL)
	CP	"6"
	JR	NZ,RP6T_NG

		;
		; 0002H version = 02H
		;
	INC	HL
	LD	A,(HL)
	CP	02H
	JR	NZ,RP6T_NG

		;
		; 0004H auto command enable = 01H
		;
	INC	HL
	INC	HL
	LD	A,(HL)
	CP	01H
	JR	NZ,RP6T_NG

		;
		; 0007H command length(low)
		;
	INC	HL
	INC	HL
	INC	HL
	LD	A,(HL)
	AND	3FH
	ADD	A,09H
	LD	(P6TCMDLEN),A

	LD	A,01H
	RET

RP6T_NG:
	XOR	A
	LD	(P6TCMDLEN),A
	RET


;
; for debug
;
;DBGMON:
;	PUSH	AF
;	PUSH	BC
;	PUSH	DE
;	PUSH	HL
;
;	LD	A,01H
;	LD	(REG_DBGTRG),A
;		;
;	LD	A,(REG_SDCTRL)
;	LD	A,(REG_SDADD+0)
;	LD	A,(REG_SDADD+1)
;	LD	A,(REG_SDADD+2)
;	LD	A,(REG_SDADD+3)
;	LD	A,(REG_BUFAD)
;	LD	A,(REG_BUFSEL)
;
;	PUSH	AF
;	LD	A,01H
;	LD	(REG_BUFSEL),A
;
;;	LD	A,03H
;;	LD	(REG_DBGTRG),A
;;
;;	LD	B,20H
;;	LD	HL,REG_FIFO_0
;;DBGL1:
;;	LD	A,(HL)
;;	INC	HL
;;	DJNZ	DBGL1
;
;	LD	A,05H
;	LD	(REG_DBGTRG),A
;
;	LD	B,20H
;	LD	HL,REG_FIFO_1
;DBGL2:
;	LD	A,(HL)
;	INC	HL
;	DJNZ	DBGL2
;
;
;	LD	A,07H
;	LD	(REG_DBGTRG),A
;
;	LD	BC,0200H
;	LD	HL,REG_SDBUF
;DBGL3:
;	LD	A,(HL)
;	INC	HL
;	DEC	BC
;	LD	A,B
;	OR	C
;	JR	NZ,DBGL3
;
;	XOR	A
;	LD	(REG_DBGTRG),A
;
;	POP	AF
;	LD	(REG_BUFSEL),A
;
;	POP	HL
;	POP	DE
;	POP	BC
;	POP	AF
;	RET

;
; offset address
;
OFFSET:		DB	00H,00H,00H,00H

;
; FAT start address
;
FATST:		DB	00H,00H,00H,00H

;
; FAT use sector number
;
FATSEC:		DB	00H,00H

;
; root directory start address
;
ROOTST:		DB	00H,00H,00H,00H

;
; claster start address (claster number is #2)
;
CLASTST:	DB	00H,00H,00H,00H

;
; claster size (x512 byte)
;
CLASTSIZE:	DB	00H

;
; directory start address (temporary)
;
DIRCL:		DB	00H,00H

;
; directory file pointer (temporary)
;
DIRPOS:		DB	00H,00H

;
; 4 byte calc work
;
WORK:		DB	00H,00H,00H,00H
WORK2:		DB	00H,00H,00H,00H
WORK3:		DB	00H,00H,00H,00H
WORK4:		DB	00H,00H,00H,00H

;
; return mode of SD error
;
SDMODE:		DB	00H

;
; read flag
;
; 00H : no selected file
; 01H : selected and no read
; 02H : selected and reading
;
READFLAG	DB	00H

;
; write flag
;
; 00H : no selected file
; 01H : selected and CMTwrite not open
; 02H : selected and CMTwrite open
;
WRITEFLAG	DB	00H

;
; SD write protect latch
;
SDWPFLAG	DB	00H

;
; display page number
;
PAGENUM		DB	00H

;
; display page redraw
;
PAGEREDRAW	DB	00H

;
; cursur redraw
;
CURSORREDRAW	DB	00H

;
; file selecter CMT/EXT.ROM
; CMT load : 04H
; ROM load : 05H
; FDD load : 06H
; CMT save : 0CH
; FDD save : 0EH
;
FILESEL		DB	00H

;
; extend rom on/off
;
EXTROMFLAG	DB	00H

;
; search file type
; 00H:file
; 10H:directory
;
SEARCHTYPE	DB	00H

;
; SD insert / eject detect timer
;
SDDETTIMER	DB	00H,00H

;
; p6t auto command enable
;
P6TCMDENB	DB	00H

;
; p6t auto command enable before
;
P6TCMDENBBEF	DB	00H

;
; p6t file read flag
;
P6TFILEREAD	DB	00H

;
; p6t auto command timer
;
KEYTIMER	DB	00H,00H

;
; p6t auto command length
;
P6TCMDLEN	DB	00H

;
; p6t buffer position
;
P6TBUFPOS	DB	00H

;
; p6t key push flag
;
P6TKEYPUSH	DB	00H

;
; control select register buffer / function key buffer
; key push detect
;
CTRLNOW		DB	00H
FUNCNOW		DB	00H,00H,00H
CTRLBEF		DB	00H
FUNCBEF		DB	00H,00H,00H
CTRLPUSH	DB	00H
FUNCPUSH	DB	00H,00H,00H

;
; cursor position address and length
;
CURSOR_ADD	DB	00H,00H
CURSOR_LEN	DB	00H

;
; claster number buffer x 20 x2
;
FILEPTR_BUF	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H

;
; strings
;
ST_PC6001F	DB	009H,00H,"PC-6001F",00H
ST_FPGAVER	DB	015H,00H,"FPGA v."
ST_FPGAVER_VAL	DB	"0000",00H
ST_FIRMVER	DB	036H,00H,"F/W v."
ST_FIRMVER_VAL	DB	"0000",00H
ST_CMTREAD	DB	061H,00H, "CMT READ FILE  ["
ST_CMTREAD_VAL	DB	"FFFFFFFF EEE]",00H
ST_CMTREW	DB	081H,00H,"CMT READ FILE REW.[  OK  ]",00H
ST_CMTWRITE	DB	0C1H,00H, "CMT WRITE FILE ["
ST_CMTWRITE_VAL	DB	"FFFFFFFF EEE]",00H
ST_MEMSIZE	DB	001H,01H,"RAM SIZE          ["
ST_MEMSIZE_VAL	DB	" 16KB ]",00H
ST_EXTROM	DB	041H,01H,"EXTEND ROM     ["
ST_EXTROM_VAL	DB	"FFFFFFFF EEE]",00H
ST_SC4COL	DB	081H,01H,"SCREEN4 COLOR    ["
ST_SC4COL_VAL	DB	"/ ]",00H

ST_P6T		DB	"P6T"


; ޳:ٷ ò:RET ·:SPC
; ݾ:ESC    :F8  ؾ:F11
;0123456789ABCDEF0123456789ABCDEF

ST_KEYFUNC1	DB	0C0H,001H
		DB	020H,092H,0E4H,0DEH,093H,03AH,0B6H,0B0H
		DB	0BFH,0D9H,0B7H,0B0H,020H,099H,08FH,0E3H
		DB	092H,03AH,052H,045H,054H,020H,0E2H,097H
		DB	0DEH,0EDH,03AH,053H,050H,043H,020H,000H
ST_KEYFUNC2	DB	0E0H,001H
		DB	020H,0B7H,0ACH,0DDH,0BEH,0D9H,03AH,045H
		DB	053H,043H,020H,020H,020H,020H,095H,0FCH
		DB	0F9H,03AH,046H,038H,020H,020H,0D8H,0BEH
		DB	0AFH,0C4H,03AH,046H,031H,031H,020H,000H

ST_FNAME	DB	00H,00H
ST_FNAME_VAL	DB	"FFFFFFFF EEE",00H

ST_DEBUG	DB	0E0H,01H,"HL:"
ST_DEBUG_VAL	DB	"0000",00H

ST_NOSELECT	DB	03DH,03DH,020H,09EH,0FDH,0E0H
		DB	098H,0E5H,09CH,020H,03DH,03DH	;"== ż =="
ST_WRPROTECT	DB	03DH,020H,096H,097H,09AH,0F0H
		DB	020H,097H,0FDH,09CH,020H,03DH	;"=  ݼ ="
ST_OFF		DB	" OFF"
ST_HIGH		DB	" ON "
ST_LOW		DB	"LOW "
ST_16		DB	" 16"
ST_32		DB	" 32"
ST_64		DB	" 64"
ST_128		DB	"128"
ST_SC4COL0	DB	0F0H,0E4H,0DEH,0F8H,02FH,0F3H,0F3H,020H	;"/ "
ST_SC4COL1	DB	0F3H,0F3H,02FH,0F0H,0E4H,0DEH,0F8H,020H	;"/ "
ST_SC4COL2	DB	020H,091H,095H,02FH,091H,096H,020H,020H	;" /  "
ST_SC4COL3	DB	020H,091H,096H,02FH,091H,095H,020H,020H	;" /  "
ST_SC4COLOFF	DB	"  OFF   "

;
; page 0 cursor data
;
PAGE0CURDATA	DB	071H,000H,00CH
		DB	094H,000H,006H
		DB	0B4H,000H,006H
		DB	0D1H,000H,00CH
		DB	0F1H,000H,001H
		DB	014H,001H,006H
		DB	031H,001H,001H
		DB	051H,001H,00CH
		DB	071H,001H,001H
		DB	093H,001H,008H

;
; BASIC-ROM directory name
;
F_ROMDIR	DB	"ROM        "

;
; P6T file buffer (63 + 10 byte)
;
P6TBUFFER
		DB	00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H

	END
